/*-
 * ~~~~~~licensing~~~~~~
 * generator-api
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.base.generator.template.impl;

import java.util.Map;
import java.util.UUID;

import ru.entaxy.platform.base.support.CommonUtils;

public class TemplateMetadata {

	protected String id = UUID.randomUUID().toString();
	protected String name;
	protected String type = "ftl";
	protected String filename;
	protected String fullname;
	protected String path;
	protected String description = "";
	protected Map<String, String> additionalProperties;
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getExactName() {
		return name;
	}
	public String getName() {
		return CommonUtils.getValid(name, id);
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getExactFilename() {
		return filename;
	}
	public String getFilename() {
		return CommonUtils.getValid(filename, getName());
	}
	public void setFilename(String filename) {
		this.filename = filename;
	}
	public String getExactFullname() {
		return fullname;
	}
	public String getFullname() {
		return CommonUtils.getValid(fullname, getFilename() + "." + getType());
	}
	public void setFullname(String fullname) {
		this.fullname = fullname;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getExactPath() {
		return path;
	}
	public String getPath() {
		if (CommonUtils.isValid(path)) {
			if (!path.startsWith("/"))
				return TemplateProvider.TEMPLATE_PATH + "/" + path;
			else
				return path;
		}
		return TemplateProvider.TEMPLATE_PATH;
	}
	public void setPath(String path) {
		this.path = path;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public Map<String, String> getAdditionalProperties() {
		return additionalProperties;
	}
	public void setAdditionalProperties(Map<String, String> additionalProperties) {
		this.additionalProperties = additionalProperties;
	}
	
}
